package com.example.kafka;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;
import java.util.HashSet;
import java.util.Set;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;
import java.util.HashSet;
import java.util.Set;

public class OrderDataGenerator {

    // 订单类别定义
    private static final String[] CATEGORIES = {"电器", "服饰", "食品", "玩具", "手机"};
    // 每个类别对应的订单名称
    private static final String[][] PRODUCT_NAMES = {
            {"电视", "冰箱", "洗衣机", "空调", "吸尘器", "电饭煲", "微波炉", "电磁炉", "热水器", "空气净化器"}, // 电器
            {"T恤", "牛仔裤", "羽绒服", "衬衫", "运动鞋", "夹克", "卫衣", "连衣裙", "短裤", "风衣"},           // 服饰
            {"巧克力", "饼干", "方便面", "牛奶", "饮料", "面包", "糖果", "果冻", "薯片", "蛋糕"},           // 食品
            {"积木", "拼图", "玩偶", "遥控车", "毛绒玩具", "魔方", "乐高", "变形金刚", "洋娃娃", "电子琴"}, // 玩具
            {"华为", "苹果", "小米", "OPPO", "vivo", "荣耀", "三星", "魅族", "联想", "努比亚"}              // 手机
    };

    private static final Random random = new Random();
    private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

    // 用于记录已生成的 categoryIndex，保证唯一性
    private static final Set<Integer> generatedCategoryIndexes = new HashSet<>();

    /**
     * 生成一条订单记录，并确保 categoryIndex 唯一
     */
    public static String generateOrder() {
        int categoryIndex;
        // 确保生成的 categoryIndex 未被使用过
        do {
            categoryIndex = random.nextInt(CATEGORIES.length);
        } while (generatedCategoryIndexes.contains(categoryIndex));

        // 添加到已生成集合
        generatedCategoryIndexes.add(categoryIndex);

        String category = CATEGORIES[categoryIndex];
        String name = PRODUCT_NAMES[categoryIndex][random.nextInt(10)];
        int quantity = random.nextInt(10) + 1;
        String date = sdf.format(new Date());
        int rating = new Random().nextInt(3) * 50; // 0, 50, 100
        String isValid = random.nextBoolean() ? "Y" : "N";

        return String.join("\t",
                category,
                name,
                String.valueOf(quantity),
                date,
                String.valueOf(rating),
                isValid);
    }

    /**
     * 清空已生成的 categoryIndex 记录，以便下一轮生成
     */
    public static void resetCategoryIndexTracker() {
        generatedCategoryIndexes.clear();
    }
}
